// RSZVL S-parameter Measurement ExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RSZVL S-parameter Measurement Example.h"
#include "RSZVL S-parameter Measurement ExampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define CHECKERR(fcal) if ((rszvl_status = fcal) < 0)\
					   {\
							cleanup(VI_FALSE);\
							return;\
					   }


// CRSZVLSparameterMeasurementExampleDlg dialog




CRSZVLSparameterMeasurementExampleDlg::CRSZVLSparameterMeasurementExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRSZVLSparameterMeasurementExampleDlg::IDD, pParent)
	, m_IDQuery(TRUE)
	, m_Reset(TRUE)
	, m_Display(FALSE)
	, m_Sout(0)
	, m_Sin(0)
	, m_SourcePower(0.0)
	, m_StartFreq(300.0e+3)
	, m_StopFreq(4.0e+9)
	, m_SweepPoints(200)
	, m_Path(_T("c:\\trace.csv"))
	, m_ResourceString(_T("GPIB::20::INSTR"))
	, m_FileName(_T("trace.csv"))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRSZVLSparameterMeasurementExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Check(pDX, IDC_IDQUERY, m_IDQuery);
	DDX_Check(pDX, IDC_RESET, m_Reset);
	DDX_Check(pDX, IDC_DISPLAY, m_Display);
	DDX_CBIndex(pDX, IDC_SOUT, m_Sout);
	DDV_MinMaxInt(pDX, m_Sout, 0, 3);
	DDX_CBIndex(pDX, IDC_SIN, m_Sin);
	DDV_MinMaxInt(pDX, m_Sin, 0, 3);
	DDX_Text(pDX, IDC_SOURCE_POWER, m_SourcePower);
	DDV_MinMaxDouble(pDX, m_SourcePower, -70.0, 20.0);
	DDX_Text(pDX, IDC_START_FREQ, m_StartFreq);
	DDX_Text(pDX, IDC_STOP_FREQ, m_StopFreq);
	DDX_Text(pDX, IDC_SWEEP_POINTS, m_SweepPoints);
	DDX_Text(pDX, IDC_PATH, m_Path);
	DDX_Text(pDX, IDC_RESOURCE_STRING, m_ResourceString);
}

BEGIN_MESSAGE_MAP(CRSZVLSparameterMeasurementExampleDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_GENERATE, &CRSZVLSparameterMeasurementExampleDlg::OnBnClickedGenerate)
	ON_BN_CLICKED(IDC_BROWSE, &CRSZVLSparameterMeasurementExampleDlg::OnBnClickedBrowse)
END_MESSAGE_MAP()


// CRSZVLSparameterMeasurementExampleDlg message handlers

BOOL CRSZVLSparameterMeasurementExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRSZVLSparameterMeasurementExampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRSZVLSparameterMeasurementExampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CRSZVLSparameterMeasurementExampleDlg::OnBnClickedGenerate()
{
	ViString window_name = "MeasSetup";
    ViString trace_name = "MeasTrace";
    ViInt32 channel = 1;
    ViInt32 window = 1;
    ViInt32 window_trace = 2;
    ViChar catalog[1024] = "";
    ViChar cat[1024] = "";
    ViChar get_dir[1024] = "";
	ViChar cur_dir[1024] = "";
    ViChar	*p2buf;
	ViChar *next_token1 = NULL;
		
	HCURSOR cur = LoadCursor ( NULL, IDC_WAIT );
	SetCursor ( cur );

	UpdateData (TRUE);
	// Initialize the driver
	rszvl_status = rszvl_init ((char *) ((LPCTSTR) m_ResourceString), m_IDQuery, m_Reset, &m_InstrSession);
	if (rszvl_status < 0) 
	{
		AfxMessageBox (_T ("Could not open the session!"), MB_OK | MB_ICONSTOP);
		cur = LoadCursor ( NULL, IDC_ARROW );
		SetCursor ( cur );
		return;
	}

	// Set display update
	CHECKERR (rszvl_ConfigureDisplayUpdate (m_InstrSession, m_Display, FALSE));
	// Create new window
	CHECKERR (rszvl_ConfigureNewSetup (m_InstrSession, window_name));
	// Retrieve the list of traces
	CHECKERR (rszvl_TraceList (m_InstrSession, channel, 1024, catalog));
	sscanf_s (catalog, "'%[^']", cat, _countof(cat));
	p2buf = strtok_s (cat, ",", &next_token1);

	while (p2buf)
	{
		// Delete all possibly opened traces
		CHECKERR (rszvl_TraceDelete (m_InstrSession, channel, p2buf));
		p2buf = strtok_s (NULL, ",", &next_token1);
		p2buf = strtok_s (NULL, ",", &next_token1);
	}
	// Create a new trace
    CHECKERR (rszvl_TraceAdd(m_InstrSession, channel, trace_name));
    CHECKERR (rszvl_TraceAssignDiagramArea(m_InstrSession, window, window_trace, trace_name));
    // Set Sweep parameters
    CHECKERR (rszvl_ConfigureSweepPoints(m_InstrSession, channel, m_SweepPoints));
    // Set single sweep and sweep count to 1
    CHECKERR (rszvl_ConfigureAcquisition(m_InstrSession, FALSE, 1));
    // Set frequencies
    CHECKERR (rszvl_ConfigureFrequencyStartStop(m_InstrSession, m_StartFreq, m_StopFreq));
    // Set Power
    CHECKERR (rszvl_ConfigureSourcePower(m_InstrSession, channel, m_SourcePower));
    // Assign a measurement parameter to a trace
    CHECKERR (rszvl_ConfigureSParameters(m_InstrSession, channel, trace_name, m_Sout + 1, m_Sin + 1));
    // Initiate measurement
    CHECKERR (rszvl_Initiate(m_InstrSession, channel, 30000));
    // Returns the directory for mass memory storage
    CHECKERR (rszvl_GetCurrentDirectory(m_InstrSession, get_dir));

	sprintf_s (cur_dir, 1024, "%s\\%s", get_dir, m_FileName);
	
	// Store trace to file
    CHECKERR (rszvl_TraceExportData(m_InstrSession, trace_name, cur_dir));
    // Copy file from instrument
    CHECKERR (rszvl_ReadToFileFromInstrument(m_InstrSession, cur_dir, (char *)(LPCSTR) m_Path));
    // Delete file from instrument
    CHECKERR (rszvl_FileManagerOperations(m_InstrSession, RSZVL_VAL_FILE_DELETE, cur_dir, ""));

	cur = LoadCursor (NULL, IDC_ARROW);
	SetCursor (cur);

	CHECKERR (rszvl_close (m_InstrSession));
}

/*===========================================================================*/
/* Function: Cleanup
/* Purpose:  Closes the VISA session to the instrument and in case of error
/*           queries the error and shows the dialog box with error message.
/*           In case Device Clear is requested, it is necessary to set the
/*           argument deviceClear to VI_TRUE.
/*===========================================================================*/
void CRSZVLSparameterMeasurementExampleDlg::cleanup(ViBoolean deviceClear)
{
	if (rszvl_status < 0)
	{
		ViChar      error_message[256];
		ViStatus    temp_status;
		CString		message;
		CString		error_string;
		
		/* Query the error message from the instrument driver. This
		 * function gets the error message for VISA and driver failures
		 */
		temp_status = rszvl_error_message(m_InstrSession, rszvl_status, error_message);
		
		if (temp_status == VI_WARN_UNKNOWN_STATUS)
		{
			/* Query the error message from the instrument. This
			 * function gets the error message directly from instrument, like
			 * execution error, out of range error etc.
			 */
			rszvl_error_query(m_InstrSession, &temp_status, error_message);
		}
		error_string = error_message;
		message.Format (_T ("Error 0x%8X occured:\n\n%s"), rszvl_status, error_string);
		AfxMessageBox (message, MB_OK | MB_ICONSTOP); 
	}
	
	/* Device Clear is a low-level command and should be used in case the
	 * instrument is waiting for Operation Complete to cancel the wait.
	 * It is useful for instance in case of incorrect external trigger
	 * when the instrument does not respond to any other command because of
	 * waiting for trigger.
	 */
	if (deviceClear)
	{
		viClear (m_InstrSession);
		viPrintf (m_InstrSession, "*CLS\n");
	}
	
	rszvl_close (m_InstrSession);

	HCURSOR cur = LoadCursor ( NULL, IDC_ARROW );
	SetCursor (cur);
}
void CRSZVLSparameterMeasurementExampleDlg::OnBnClickedBrowse()
{
	CFileDialog fileDlg( FALSE);

	if ( fileDlg.DoModal() == IDOK)
	{
		m_Path = fileDlg.GetPathName();
		m_FileName = fileDlg.GetFileName();
		UpdateData(FALSE);
	}
}
